"use strict";

/*
Copyright 2021 Q-CTRL. All rights reserved.

Licensed under the Q-CTRL Terms of service (the "License"). Unauthorized
copying or use of this file, via any medium, is strictly prohibited.
Proprietary and confidential. You may not use this file except in compliance
with the License. You may obtain a copy of the License at

     https://q-ctrl.com/terms

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS. See the
License for the specific language.
*/
var _ = require("lodash");

var Color = require('color');

function flattenColorPalette(colors) {
  var result = _(colors).flatMap(function (color, name) {
    if (!_.isObject(color)) {
      return [[name, color]];
    }

    return _.map(color, function (value, key) {
      var suffix = key === 'DEFAULT' ? '' : "-".concat(key);
      return ["".concat(name).concat(suffix), value];
    });
  }).fromPairs().value();

  return result;
} // Get color R,G,B as a sting


function getRGB(color) {
  var currentColor = Color(color).object();
  var colorRGB = currentColor.r + ', ' + currentColor.g + ', ' + currentColor.b;
  return colorRGB;
} // Remove hash


function removeHash(color) {
  if (color.includes('#')) {
    return color.replace('#', '');
  }

  return color;
}

module.exports = {
  flattenColorPalette: flattenColorPalette,
  getRGB: getRGB,
  removeHash: removeHash
};